/*
   for C++
   misc.h
   */


#ifndef __MISC_H__
#define __MISC_H__


#ifndef NULL
#define NULL 0
#endif

#ifndef BUFSIZE
#define BUFSIZE 1024
#endif

#ifndef True
#define False 0
#define True  1
#endif


typedef unsigned char  UC;
typedef unsigned short US;
typedef unsigned int   UI;
typedef unsigned long  UL;


#include <string.h>


inline char *new_string(const char *str)
{
  if (!str) return NULL;
  char *r=new char[strlen(str)+1];
  strcpy(r, str);
  return r;
}


inline void delete_string(char *&str)
{
  if (str) delete [] str;
  str=NULL;
}


inline int compare_string(const char *s1, const char *s2)
{
  if (!s1 && !s2) return  0;
  if (!s1 &&  s2) return -1;
  if ( s1 && !s2) return  1;
  return strcmp(s1, s2);
}


inline char *remove_newline(char *s)
{
  int n=strlen(s);
  if (n>0 && s[n-1]=='\n') s[n-1]='\0';
  if (n>1 && s[n-2]=='\r') s[n-2]='\0';
  return s;
}


// size  '\0' ޤ
char *strtolower(char *str);
char *strtoupper(char *str);
char *ntolower_string(char *str, int size);
char *ncopy_string(char *dest_str, const int dest_size, const char *src_str);
char *ncat_string(char *dest_str, const int dest_size, const char *src_str);
char *ULto_string(UL n);
int nlengh_string(const char *str, const int size);
int ncreate_multi_string(char *dest_mstr, const int dest_size, const char * const *src_str, const int src_n);
int nseparate_multi_string(const char **dest_str, const int dest_n, const char *src_mstr, int src_size);

#define ncpy_string  ncopy_string
#define nlen_string  nlengh_string
#define ncrt_mstring ncreate_multi_string
#define nsep_mstring nseparate_multi_string
#ifndef min
#define min(a,b) (((a)>(b))?(b):(a))
#endif
#ifndef max
#define max(a,b) (((a)>(b))?(a):(b))
#endif
#ifndef abs
#define abs(i) (((i)>=0)?(i):-(i))
#endif


#ifdef DEBUG
#include <stdio.h>
#define DEBUGOUT(s)  fprintf(stderr, "%s\n", s)
#define DEBUGOUTn(s) fprintf(stderr, "%s", s)
#define DEBUGINT(i)  fprintf(stderr, "%d\n", i)
#define DEBUGINTn(i) fprintf(stderr, "%d", i)
#else
#define DEBUGOUT(s)
#define DEBUGOUTn(s)
#define DEBUGINT(i)
#define DEBUGINTn(i)
#endif


#if TARGET_OS==unix
#include <stdlib.h>
// 褤ॸͥ졼
#define Rand random
#define Srand srandom
#endif

#endif
